
package com.dms.ejb.messaging;

import java.sql.Connection;

import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;

import org.apache.log4j.Category;

import org.jboss.ejb3.annotation.ResourceAdapter;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;


@MessageDriven(name = "SubmissionMDB",
        activationConfig =
              { 
                 @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
                 @ActivationConfigProperty(propertyName = "providerAdapterJNDI", propertyValue = "DefaultJMSProvider"),
                 @ActivationConfigProperty(propertyName = "DLQJNDIName", propertyValue = "queue/DLQ"),
                 @ActivationConfigProperty(propertyName = "minSession", propertyValue = "1"),
                 @ActivationConfigProperty(propertyName = "subscriptionDurability", propertyValue = "Durable"),
                 @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "AUTO_ACKNOWLEDGE"),
                 @ActivationConfigProperty(propertyName = "maxSession", propertyValue = "15"),
                 @ActivationConfigProperty(propertyName = "maxMessages", propertyValue = "1"),
                 @ActivationConfigProperty(propertyName = "useDLQ", propertyValue = "true"),
                 @ActivationConfigProperty(propertyName = "DLQMaxResent", propertyValue = "10"),                 
                 @ActivationConfigProperty(propertyName = "messageSelector", propertyValue = "color = 'RED'")
              })
@TransactionManagement(value= TransactionManagementType.CONTAINER)
@TransactionAttribute(value= TransactionAttributeType.REQUIRED)
@ResourceAdapter("hornetq-ra.rar")
  

public class SubmissionMDB extends ParentEntityBean implements MessageDrivenBean,MessageListener {
      
private static final long serialVersionUID = 1L;
private MessageDrivenContext mdc = null;
           
    public QuoteSubmissionMDB() throws Exception{
     System.out.println(className+"::QuoteSubmissionMDB()");
    }

    public void setMessageDrivenContext(MessageDrivenContext mdcv){
     System.out.println(className+"::setMessageDrivenContext()");
        this.mdc = mdcv;
    }

    public void ejbCreate() {
     System.out.println(className+"::ejbCreate()");
    }
   
    /*
     * onMessage receives Message and forward the message to the Util class to 
     * Create the SOAPMessage
     * (non-Javadoc)
     * @see javax.jms.MessageListener#onMessage(javax.jms.Message)
     */
    public void onMessage(Message inMessage) {
     final String methodName="onMessage";
     System.out.println("In QuoteSubmissionMDB.onMessage()");
     MapMessage msg=null;
     Connection con=null;

     try {         
         if(inMessage instanceof MapMessage){            
          msg = (MapMessage) inMessage;
          String userName="";
          
          /*
           * Get the Details from the Message Map.
           */
             System.out.println("username"+msg.getString("Username"));
             
            
         }else{
         System.out.println(className+"::"+methodName+"::Message of wrong type: "+inMessage.getClass().getName());                                            
         }   
     }catch (Exception e){
      System.out.println(methodName+"::Exception is: " + e.toString());       
     }finally{
      try{
      if(con!=null){
       con.close();
      }
      }catch(Exception e){
       System.out.println(methodName+"::Exception is: " + e.toString());  
      }
     }
    }
    public void ejbRemove() {
     mdc=null;
     System.out.println(className+"::ejbRemove()");
    } 
}